#!/usr/bin/perl

use DB_File;

$PageLength = 4; # 6 rows per page.
$RowSize =5; # image per row
$PixPerPage = $PageLength * $RowSize;

db_connect();

$q = new CGI, unless $q;

$User = Userverify($q,1);

if (defined($q->param('album'))) {
	$Album = $q->param('album');
}


$Page = $q->param('page'); # Page number to display
$Mode = $q->param('mode'); # 1 = show public page
$Mode = 0, if $Mode != 1;

$Page = 1, if ($Page < 1);

@Images = AlbumListPix($Album);
$Descr = AlbumDescr($Album, 0, "");
$atitle = AlbumTitle($Album, 0, "");
$Last = AlbumLastImg($Album);

$Apublic = AlbumPublic($Album);

(undef, $owner) = AlbumIdName($Album);
if ($owner !~ /^$User$/ && $Apublic != 1) {
	warn "User $User not authorised to view album $Album";
	print "Location: $Referer\n\n";
	exit(0);
}

($create, $access, $update) = AlbumGetAxs($Album, 0);
$create = DateCmp($create);
$access = DateCmp($access);
$update = DateCmp($update);

$Npix = 0;
$plast = 0;
$plastnum = 0;
@Pix = ();
@px = ();
$Allowed = 0;
@Pub = ();

# array of displayed pictures
@PicArray = GetPublicPix();


# number of pix displayed in album
$NumPix = $#PicArray + 1;

# number of pages album takes
$NumPages = $NumPix/$PixPerPage;
$NumPages = int($NumPages) + 1, if ($NumPages > int ($NumPages));

$Page = $NumPages, if ($Page > $NumPages);

# first and last image index in the page
$PageFirst = (($Page - 1) * $PixPerPage) + 1;
$PageLast = $NumPix > $Page * $PixPerPage ? $Page * $PixPerPage  : $NumPix;


# number of pictures on page
$PagePix = ($PageLast - $PageFirst+1);

#warn "First: $PageFirst, last: $PageLast, Page $Page, Total $#PicArray, PixPerPage $PixPerPage, NumPix $NumPix, PagePix $PagePix";

# generate the HTML string for the thumbnails
foreach $pic ($PageFirst .. $PageLast) {
	$imgnum = $PicArray[$pic-1];
	my($str) = ShowImage($imgnum, 1, "", 0, $Album) . "_BR33D=_$imgnum";
	push(@Pix, $str);
}

# get a list of photos viewable by the current user

sub GetPublicPix {
my($str);
my($qry, $id, $pub);
my($pix, $owner);
my(@pix,@tmp, @NotCached) = ();
	
	tie %db, 'DB_File', "cache/image" or warn "Can't init cache db: $!";
	while ($img = pop @Images) {
		push (@NotCached, $img), if (!exists($db{$img}) || $db{$img} =~ /^$/);
		push(@tmp, $img);
	}
	if (@NotCached > 0) {
		$str = "SELECT imageid, pub, owner, albumrefcount FROM photos WHERE ";
		while ($img = pop @NotCached) {
			$str .= "imageid = $img or ";
			$ff = $img;
		}
		$str .= "imageid = $ff";
		$qry = $Db_Conn->prepare($str);
		$qry->execute;
		while (@flim = $qry->fetchrow_array) {
			($id, $pub, $owner, $albref) = @flim;
			$db{$id} = "$pub:$owner:$albref";
		}
	}
	while ($img = pop @tmp) {
		my($pub,$owner,$albref) = split(/:/, $db{$img});
		push(@pix, $img), if ($pub || ($User eq $owner && $Mode == 0));
	}
	return @pix;
}

$nextpage = $plast == $Last ? 1 : $Page + 1;
$prevpage = $Page == 1 ? 1 : $Page - 1;
$blank = $RowSize-1;
$tm = localtime(time + 84000);
if ($User eq "nobody") {
	UpdateAccess($Album, 0, 1);
}

print "Expires: $tm\n";

# Display public / private indicators


if ($Mode == 1 && $Apublic && $User eq $owner) { # show public page to owner
	$othermode = "<small><a href=albumshow?album=$Album&page=1>private page</small></a>";
	$pagemode = "&mode=1";
} elsif ($Apublic && $User eq $owner) {  # show private page to owner
	$othermode = "<small> <a href=albumshow?album=$Album&page=1&mode=1>public page</small></a>";
	$pagemode = "";
} else {  # show lock icon, unless public viewing
	$othermode = "<img border=0 src=\"$IcoUrl/mini-lock.gif\" width=16 height=14></a>", unless ($Apublic);
	$pagemode = "";
}

# header and help box javashit stuff

PrintHeader($User, "PhotoShelf: Album $atitle", "", "Album view");
print <<EOF;
<script language=javascript source=$Repos_Url/functions.js>

</script>
EOF

# Albums:Europe:Amsterdam

print "<table width=90% align=center><tr><td align=left valign=top>";
print AlbumShowAncestor($Album,$atitle);
print "</td><td align=center valign=bottom>";
print "<font size=+1>$Descr</font>";
print "</td><td align=right valign=top>";
print "<b>$NumPix images</b>";
print "(showing $PageFirst thru " , $PageLast + 0 , ")$othermode";
print "</td></tr></table>";

$npages = $Allowed / ($PageLength * $RowSize);

# Page number list
PageList();

$IamOwner = (AlbumOwner($Album) eq $User);

print "<table align=center cellpadding=2 border=1 cellspacing=1 bgcolor=$TableHighBG>\n<tr>\n";
$n = 0;

# print thumbnails and edit/delete/move bits for each.

foreach $bit (@Pix) {
	($html, $img) = split(/_BR33D=_/, $bit);
	if ($IamOwner && $Mode != 1) {
		my($pub,$owner,$albref) = split(/:/, $db{$img});
		$lockicon = ((!$pub && $Apublic) ? " | <a href=edit?id=$img&unlock=1 OnClick=\"return UnLock($img)\"><img border=0 src=$IcoUrl/mini-lock.gif width=16 height=14></a>" : "");
		$confdel = ($albref < 2 ? "OnClick=\"return ConfirmDel()\"" : "");
		$editbits = <<EOF;
<tr bgcolor=$AlbToolBG><td>
	<a href=albumedit?album=$Album&id=$img&move=up><font color=$AlbToolFG><b>&lt;-</b></a></td>
<td align=center valign=bottom>
	<a href=albumedit?album=$Album&id=$img&delete=1 $confdel>
		<font color=$AlbToolFG>Del</a> |
	<a href=edit?refalbum=$Album&id=$img>
		<font color=$AlbToolFG>Edit</a>$lockicon</td>
<td>
	<a href=albumedit?album=$Album&id=$img&move=down><font color=$AlbToolFG><b>&nbsp;-&gt;</b></a>
</td></tr>
EOF
	} else {
		$editbits = "";
	}
# if only one pic, set colspan to 2 for hammer and help cells
	if ($PagePix == 1) {
		$rowpad = "colspan=2";
	} else {
		$rowpad = "";
	}
	print "<td valign=bottom $rowpad><table border=0 align=center cellspacing=1 cellpadding=1><tr><td>&nbsp;</td>$html</td><td>&nbsp;</td>";
	$n++;
	print <<EOF;
</tr>
$editbits 
</table></td>
EOF

# Create new row when the current one is full
	if ($n >= $RowSize) {
		print "\n</tr><tr>\n";
		$n = 0;
	}
}

#warn "PagePix $PagePix, RowSize $RowSize";

# Pad out empty thumbnail table cells
if ($PagePix < $RowSize) {
	$RowSize = $PagePix;
} else {
	$pad = $RowSize - $n;
	print "<td colspan=$pad>&nbsp;</td>", if ($n <= $RowSize && $n != 0);
}

# print hammer and help icons

print "<tr bgcolor=$BGNorm>\n";
$span = $RowSize - 2;
print "<td align=left valign=center>";
if ($owner eq $User && $atitle ne "Default" && $Mode != 1) {
	print "<a href=albumedit?album=$Album><img border=0 src=$IcoUrl/mini-hammer.gif width=16 height=14></a>";
} else {
	print "&nbsp;";
}
print <<EOF;
	</td>
	<td colspan=$span align=right>
		<font face="arial,helvetica,sans-serif">
		<b>Created:</b> $create | <b>Updated:</b> $update | <b>Accessed:</b> $access
		</font>
	</td>
	<td align=right>
	<small><a href="javascript:popUp('help.cgi?topic=albumshow')">Help</a></small>
</td></tr>
</table><br>
EOF

# bottom page list
PageList();

# access time/invite table
print <<EOF;
<p>
<center>
<table border=0 bgcolor=$TableHighBG>
EOF
if ($Apublic && $IamOwner && $Mode == 0) {
	print <<EOF;
<tr>
<td colspan=3>
<form action=albuminvite method=post>
<p><b>Invite someone to this album!<br></b>
Email: <input type=text name=email size=20>
<input type=hidden name=album value=$Album>
<input type=submit value="Invite!">
</form>
</td>
EOF
}

print <<EOF;
</tr>
</table>
</center>
<p>
EOF

untie %db;

PrintFooter();


sub PageList {
	return , if ($NumPages < 2);
	print "<center>\n";
	if ($Page > 1) {
		print "<a href=albumshow?album=$Album&page=$prevpage$pagemode><font color=#5555ff>&lt;&nbsp;Prev</font></a>&nbsp;|&nbsp;";
	} else {
		print "<font color=#bbbbbb>&lt;&nbsp;Prev</font>&nbsp;|&nbsp;";
	}
	foreach $n (1 .. $NumPages) {
		print "<a href=albumshow?album=$Album&page=$n$pagemode><font color=#5555ff>", unless ($Page == $n);
		print "<b>", if ($Page == $n);
		print $n;
		print "</b>", if ($Page == $n);
		print "</a>", unless ($Page == $n);
		print "</font>&nbsp;|&nbsp;";
	}
	if ($nextpage <= $NumPages) {
		print "<a href=albumshow?album=$Album&page=$nextpage$pagemode><font color=#5555ff>Next&nbsp;&gt;</font></a></center>";
	} else {
		print "<font color=#bbbbbb>Next&nbsp;&gt;</font></center>";
	}
}
