#!/usr/bin/perl

# search.pl
#
# Handles search requests, displays photos matching search
# criteria
#

db_connect();

$User = Userverify($q,-1);

# Given a search term, returns a list of matching image ids
#
# returns -1 on error;

sub FindImages {
my($Term) = @_;
my(@Matches) = ();
undef $Found;

	if ($Term !~ /^[0-9a-z,\._ \[\]\*]+$/i) {
#		print "\n\nError in search terms!\n";
		return -1;
	}
	foreach $field ("keywords", "caption", "comment", "filename") {
		$qry = sprintf ("SELECT imageid FROM photos WHERE %s ~* '%s' AND" .
						" (owner = '$User' OR pub = 't')",
						$field, $Term, $User);
		warn "doing $qry";
		$res = $Db_Conn->prepare($qry);
		$res->execute;
		while (@row = $res->fetchrow_array) {
			($id) = @row;
			next, if ($Found{$id});
			$Found{$id}++;
			push(@Matches, $id);
		}
	}
	return @Matches;
}

# Display image thumbs in a table
#
# takes a list of imageids

sub DisplayThem {
my(@Files) = @_;
my($n) = 0;

	$Trm = $term;
	PrintHeader($User, "Search results for $term", "", "Search results");
	print <<EOF;

<script language="JavaScript">
<!--
function mark_all(check) {
    var i;
    l = document.addform.elements.length;
    for (i=0; i < l; i++) {
            document.addform.elements[i].checked=check;
    }
}
// -->
</script>

<center>
Search results for: <b>$term</b><p>
<form method=post action=albumaddpic name=addform>
<table cellpadding=1 border=0 bgcolor=$TableHighBG><tr>
EOF

	foreach $image (@Files) {
		print ShowImage($image, 1, "", 1);
		$n++;
		if ($n > 4) {
			print "</tr><tr>";
			$n = 0;
		}
	}
	$str = $Trm;

print "</tr></table>";

@Albums = AlbumList($User, -1);
if ($#Albums >= 0) {
print <<EOF;
Add selected to Album: 
<select name=albuminsert>
EOF

	foreach $alb (sort @Albums) {
		($owner, $album,$id) =split(/:/, $alb);
		print  "<option value=$id>$album\n", if ($owner eq $User);
	}

print <<EOF;
</select>
<input type=checkbox name=movethem value=1>Move from default
<a href=javascript:mark_all(true)>Check all</a>
<a href=javascript:mark_all(false)>Uncheck all</a>
<br>
<input type=submit value="Add images">
</form>
EOF
}
print <<EOF;
<a href=search.cgi?edone=0&terms=$str>Edit all</a>
&nbsp;|<a href=search.cgi?&vdone=0&terms=$str>View all</a>
EOF

}

db_connect();

$q = new CGI, unless $q;

$term = $q->param('terms');
#$term = $q->url_decode($term);
$stype = $q->param('searchtype');
$editone = $q->param('edone');
$viewone = $q->param('vdone');

if ($term =~ /^$/ && $editone =~ /^$/ && $stype !~ /full/ && $viewone =~ /^$/) {
	PrintHeader($User, "Full Search", "", "Full Search");
	goto SEARCHBOX;
}

if ($stype eq 'full') {
	@them = FullSearch($term);
} else {
	@them = FindImages($term);
}

@them = sort(@them);

if ($editone =~ /^[0-9]+$/) {
	$file = @them[$editone];
	$editone++;
	exec "scripts/edit.cgi", $file, $editone, "$term";
	exec "./edit.cgi", $file, $editone, "$term";
	exit(1);
}

if ($viewone =~ /^[0-9]+$/) {
	$file = @them[$viewone];
	$viewone++;
	exec "scripts/image.cgi", $file, $viewone, "$term";
	exec "./image.cgi", $file, $viewone, "$term";
	exit(1);
}



DisplayThem(@them);

#if ($#them >= 0) {
	print QuickSearch();
	if ($term ne "") {
		PrintFooter();
		exit(0);
	}
#}
	

SEARCHBOX:

print "<p>";
print <<EOF
<title>PhotoShelf: Search</title>
<form method=post action=search>
<center>
<table border=1 bgcolor=$TableHighBG>
<tr bgcolor=$TableLowBG><th><font color=$TextLoTable>Advanced Search</th></tr>
<tr><td><font color=$TextTable>
<input type=hidden name=searchtype value=full>
EOF
;
ShowTables();
print <<EOF
</td></tr></table></center><br>
EOF
;
PrintFooter();


sub ShowTables {

	$NonEditTable = "<td><table border=1><tr><th colspan=2>$file</th></tr>";
	$EditTable = "<table border=1 align=top bgcolor=$TableHighBG><tr><th colspan=4>Technical info</th></tr>\n";
	$EditSubTable = "";
	MakeTables();
	print "\n\n<table><tr><td>";
	print "\n\n$EditTable";
	print "</td><td><table border=1 bgcolor=$TableHighBG><tr><th colspan=4>Subject information</th></tr><tr>$EditSubTable</table></td></tr>";
#	print  QuickSearch($term);
	print "</table>\n";
}

sub MakeTables {
my($n) = 0;
	foreach $field (0..$#DisplayedInfo) {
		$dbvar = $DisplayedInfo[$field][0];
		$descr = $DisplayedInfo[$field][1];
		$convert = $DisplayedInfo[$field][2];
		$editable = $DisplayedInfo[$field][3];
		$string = $DisplayedInfo[$field][4];
		$subjinfo = $DisplayedInfo[$field][5];
#		$desc = ${$dbvar};
		$desc = "";
#		$desc =~ s/__APOSTROPHE__/\'/g, if ($vartype == 0);
		if ($editable) {
			if ($subjinfo) {
				$tab = "EditSubTable";
			} else {
				$tab = "EditTable";
			}
		} else {
			$tab = "NonEditTable";
		}
		if ($convert) {
			($undef, $desc) = db_id_to_nd($dbvar, $desc);
		}
		${$tab} .= "\n\n<td class=imgeditvar bgcolor=$TableLowBG><font size=-1 color=$TextLoTable>$descr</td>\n";
		if ($editable) {
			my($len) = length($desc);
			$len = 10, unless $len > 5;
			$len = 20, unless $len < 21;
			if ($convert) {
				${$tab} .= "<td style=imgeditval bgcolor=$TableHighBG><select name=$dbvar><option>\n";
				@vars = list_types($dbvar);
				foreach $var (@vars) {
					($id,$nam,$des) = split(/:/, $var);
					$sel = ($desc eq $des ? "selected" : "");
					${$tab} .= "<option value=$id $sel>$nam\n";
				}
				${$tab} .= "</select></td>\n";
			} else {
				${$tab} .= "<td style=imgeditval bgcolor=$TableHighBG><font size=-1 color=$TextLoTable><input type=text name=$dbvar value=\"$desc\" size=$len></td>\n";
			}
			$n{$tab}++;
			${$tab} .= "</tr><tr>\n", if ($n{$tab} % 2 == 0);
		} else {
			${$tab} .= "<td bgcolor=$TableHighBG style=imgeditval><font size=-1 color=$TextTable>&nbsp;$desc</td></tr>\n";
		}
	}
	$EditTable .= "</table>";
	$EditSubTable .= "<tr><td colspan=4 align=center style=imgeditval><input type=submit value=\"Cancel\" OnClick=\"javascript:history.go(-1)\">&nbsp;<input type=submit value=\"Search\"></td></tr></table>\n\n\n";
#	$imgfil = "display.cgi?id=$Imageid&type=0";
	$imgfil = $URI . db_get_image_file($id,0);
	$NonEditTable .= "<tr><td colspan=2 align=center><img src=$imgfil><br>Thumbnail</td></tr></table>\n";
}

sub FullSearch {
my($DoneOne) = 0;
my($Found) = "";
my(@Matches) = ();

	$qry = "SELECT imageid FROM photos WHERE ";
	foreach $field (0..$#DisplayedInfo) {
		$dbvar = $DisplayedInfo[$field][0];
		$string = $DisplayedInfo[$field][4];
		if (defined($q->param($dbvar))) {
			$var = $q->param($dbvar);
			next, if ($var =~ /^$/);
			$qry .= " AND ", if ($DoneOne);
			if ($string) {
				$qry .= sprintf (" %s ~* '%s'",
					$dbvar, $var);
			} else {
				$qry .= sprintf (" %s = %d",
					$dbvar, $var);
			}
			$DoneOne++;
		}
	}
	$res = $Db_Conn->prepare($qry);
	$res->execute;
	while (@row = $res->fetchrow_array) {
		($id) = @row;
		next, if ($Found{$id});
		$Found{$id}++;
		push(@Matches, $id);
	}
	return (@Matches);
}
